(define-module (kulupu packages federation)
	#:use-module (gnu packages databases)
	#:use-module (gnu packages rails)
	#:use-module (gnu packages ruby)
  #:use-module (guix)
  #:use-module (guix git-download)
  #:use-module (guix build-system ruby)
  #:use-module ((guix licenses)
                #:prefix license:)
  #:use-module (kulupu packages ruby))

(define-public bundler-2
  (package
    (inherit bundler)
    (version "2.4.13")
    (source (origin
              (method url-fetch)
              (uri (rubygems-uri "bundler" version))
              (sha256
               (base32
                "12sswyrzx2lkl79hh33ckfnaz6bdjbl9nzmzanynsz2hmsjklr8i"))))))

;; TODO Remove when https://github.com/dlindahl/omniauth-cas/pull/68 is merged
(define omniauth-cas-4211e6d
  (package
    (inherit ruby-omniauth-cas)
    (name "omniauth-cas-4211e6d")
    (version "2.0.0")
    (source (origin
              (method git-fetch)
              (uri (git-reference
                    (url "https://github.com/stanhu/omniauth-cas")
                    (commit "4211e6d05941b4a981f9a36b49ec166cecd0e271")))
              (file-name (git-file-name name version))
              (sha256
               (base32
                "1zs0xp062f6wk7xxy8w81838qr855kp7idbgpbrhpl319xzc1xkc"))))
    (arguments
     (list #:tests? #f))))

(define-public mastodon
	(package
		(name "mastodon")
		(version "4.1.6")
		(build-system ruby-build-system)
		(source (origin
							(method url-fetch)
							(uri (string-append "https://github.com/mastodon/mastodon/archive/refs/tags/v" version ".tar.gz"))
							(sha256
							 (base32
								"0hgmyfzkgg6ph8632brppi4y5ll8y6vxyl91qw6a8dr1nrc0r1iq"))))
		(native-inputs (list bundler-2
												 ;;ruby-rspec-chunked
												 ruby-fuubar
												 ;;ruby-rspec-sidekiq
												 ruby-capybara
												 ruby-selenium-webdriver
												 ruby-database-cleaner-active-record
												 ruby-climate-control
												 ruby-faker
												 ;;ruby-fabrication
												 ;;ruby-rails-controller-testing
												 ruby-json-schema
												 ruby-rack-test
												 ruby-simplecov
												 ruby-webmock

                         ruby-memory-profiler
                         ruby-ruby-prof
                         ruby-stackprof
                         ;;ruby-test-prof

                         ruby-rspec-rails))
    (inputs (list ruby-hcaptcha
                  ruby-rubyzip
																				;ruby-net-http
                  ruby-cocoon
                  ruby-xorcist
                  ruby-lograge
                  ruby-private-address-check
                  ruby-rdf-normalize
                  ruby-json-ld
                  ruby-json-ld-preloaded
                  ruby-webauthn
                  ruby-webpush
                  ruby-webpacker
                  ruby-tzinfo-data
                  ruby-twitter-text
                  ruby-strong-migrations
                  ruby-stoplight
                  ruby-sprockets-rails
                  ruby-simple-form
                  ruby-simple-navigation
                  ruby-sidekiq-bulk
                  ruby-sidekiq-unique-jobs
                  ruby-sidekiq-scheduler
                  ruby-sidekiq
                  ruby-scenic
                  ruby-sanitize
                  ruby-progressbar
                  ruby-rqrcode
                  ruby-mario-redis-lock
                  ruby-redis-lock
                  ruby-redis
                  ruby-redcarpet
                  ruby-rails-settings-cached
                  ruby-rails-i18n
                  ruby-rack-cors
                  ruby-rack-attack
                  ruby-premailer-rails
                  ruby-pundit
                  ruby-public-suffix
                  ruby-posix-spawn
                  ruby-parslet
                  ruby-ox
                  ruby-oj
                  ruby-nsa
                  ruby-nokogiri
                  ruby-mime-types
                  ruby-link-header
                  ruby-kaminari
                  ruby-idn-ruby
                  ruby-httplog
                  ruby-http-accept-language
                  ruby-http
                  ruby-htmlentities
                  ruby-redis-namespace
                  ruby-hiredis
                  ruby-fastimage
                  ruby-fast-blank
                  ruby-ed25519
                  ruby-doorkeeper
                  ruby-discard
                  ruby-color-diff

                  ruby-omniauth-rails-csrf-protection
                  ruby-omniauth
                  ruby-omniauth-openid-connect
                  ruby-omniauth-saml
                  omniauth-cas-4211e6d
                  ruby-net-ldap

                  ruby-devise-two-factor
                  ruby-devise
                  ruby-chewy
                  ruby-charlock-holmes
                  ruby-browser
                  ruby-addressable
                  ruby-active-model-serializers

                  ruby-blurhash
                  ruby-kt-paperclip
                  ruby-fog-core

                  ruby-dotenv-rails
                  ruby-pghero
                  ruby-pg
                  ruby-haml-rails

                  ruby-rack
                  ruby-thor
                  ruby-sprockets
                  ruby-rails
                  ruby-puma))
    (arguments
     (list
      #:tests? #f ;; FIXME Tests breaking due to the omniauth-cas dependency
      #:phases #~(modify-phases %standard-phases
                   (add-before 'build 'set-bundle-config
                     (lambda _
                       (begin
                         (invoke "bundle" "config" "deployment" "'true'"))))
                   (delete 'replace-git-ls-files) ; No gemspec
                   (delete 'build) ; No gemspec
                   ;; FIXME Properly install mastodon
                   ;; Skipping since there is no gemspec
                   (delete 'install))))
    (synopsis "")
    (description "")
    (home-page "https://joinmastodon.org/")
    (license license:agpl3)))
